require("Tserial")
require("shaders")
love.graphics.setDefaultFilter( "nearest","nearest")
love.window.setTitle("Pixi Evolution Simulator [WIP]")
pixelSize = 3
WIDTH = math.floor(1200/pixelSize)*pixelSize
HEIGHT = math.floor(950/pixelSize)*pixelSize
panelWidth = 325
love.window.setMode(WIDTH+panelWidth, HEIGHT, {centered=true, msaa=0,resizable=false, vsync=false})
--testValue = 0
function love.load()
	rendering = true

	mutationRate = 0.005

	geneSize = 12
	bpMaxSize = 10
	geneCount = 59

	baseRadius = 3
	maxRadius = 45
	cellID = 1
	speciesID = 1
	numCells = 0
	startingEnergy = 1500
	collisionAge = 100
	cellList = {}
	maxCells = 150

	currentCell = nil
	parent1 = nil
	parent2 = nil

	numSenses = 25
	numActions = 11

	broadcasts = {}

	speciesList = {}
	speciesColors = {}
	numSpecies = 0
	speciesFiles = {}

	gridSize = math.ceil(((WIDTH+HEIGHT)/2)/(2*maxRadius))
	cellGrids = {}
	foodGrids = {}
	for i=1,gridSize,1 do
		cellGrids[i] = {}
		foodGrids[i] = {}
		for j=1,gridSize,1 do
			cellGrids[i][j] = {}
			foodGrids[i][j] = {}
		end
	end

	foodSize = pixelSize*1.5
	foodEnergy = 220
	foodDensity = 0.75
	maxFood = math.floor((WIDTH*HEIGHT*foodDensity) / 8500)
	numFood = 0
	foodID = 0
	foodList = {}
	for i=1,maxFood,1 do
		newFood()
	end

	--love.window.setMode(WIDTH, HEIGHT, {centered=true, msaa=0,resizable=false, vsync=false, minwidth=800, minheight=600})
	math.randomseed(os.time())

	startTime = love.timer.getTime()
	tickCounter = 0

	love.graphics.setPointSize(pixelSize)
	showStats = false
	showBrain = false

	for i=1,50,1 do
		local spawnedC = newCell(math.random(10,WIDTH-10),math.random(10,HEIGHT-10),startingEnergy)
	end

	collided = false
	fps = 0
	tmpTime = 0
	tmpFrame = 0

	updateSpeciesFiles()


end

function love.update(dt)
	tmpTime = tmpTime + dt
	tmpFrame = tmpFrame + 1
	if tmpFrame > 30 then
		fps = tmpFrame/tmpTime
		tmpFrame = 0
		tmpTime = 0
	end
	local currentTime = love.timer.getTime()
	local tick = false
	if currentTime - startTime >= 1/ticksPerSecond then
		startTime = currentTime
		tick = true
		tickCounter = tickCounter + 1
	end

	if tick then
		for i=1,table.getn(cellList),1 do
			local c = cellList[i]
			if cellList[i] ~= nil then
				checkHeartDamage(c)
			end
		end
		if numCells < 5 then
			for i=1,25,1 do
				local spawnedC = newCell(math.random(10,WIDTH-10),math.random(10,HEIGHT-10),startingEnergy)
				cross(spawnedC,spawnedC,math.random(10,WIDTH-10),math.random(10,HEIGHT-10),startingEnergy)
			end
		end
		local tmpSpecies = 0
		for s,n in pairs(speciesList) do
			if n > 1 then
				tmpSpecies = tmpSpecies + 1
			end
		end
		broadcasts = {}
		if math.random() > math.sqrt(numFood/maxFood) and numCells < maxCells then
			newFood()
		end
		checkFoodCollisions()
		checkCollisions()
		for i=1,table.getn(cellList),1 do
			local c = cellList[i]
			c.age = c.age+1
			c.breedTimer = c.breedTimer+1
			if c.intangible > 0 then c.intangible = c.intangible-1 end
			if c.age>100 and c.stunned==0 then
				getSenses(c)
				getActions(c)
			end
			if c.stunned>0 then c.stunned = c.stunned-1 end
			if c.shake>0 then c.shake = c.shake-1 end
			if c.isAnimated and c.age%2==0 then
				c.skin = c.skin*0.9995
				c.shader:send("n",c.skin)
			end
		end
		if numSpecies == 1 and numCells >= 15 then
			while numCells > 20 do
				killCell(cellList[math.random(1,table.getn(cellList))])
			end
			for i=1,15,1 do
				local spawnedC = newCell(math.random(10,WIDTH-10),math.random(10,HEIGHT-10),startingEnergy)
				cross(spawnedC,spawnedC,math.random(10,WIDTH-10),math.random(10,HEIGHT-10),startingEnergy)
			end
		end
	end
end

paused = false
addingNewCells = false
savingGenome = false
breeding = false
addingFood = false
loadingSpecies = false
breedOnClick = false
ticksPerSecond = 32
currentTickRate = 60

function love.keypressed(key)
	if key=="up" and rendering and not paused then
		currentTickRate = currentTickRate * 2
		ticksPerSecond = currentTickRate
	end
	if key == "down" and rendering and not paused then
		currentTickRate = round(currentTickRate/2)
		ticksPerSecond = currentTickRate
	end
	if key == "n" and not holdingKey then
		addingNewCells = true
		holdingKey = true
	end
	if key=="space" then
		paused = not paused
		if paused then ticksPerSecond = 0
		else ticksPerSecond = currentTickRate end
	end
	if key=="g" and not holdingKey then
		savingGenome = true
		holdingKey = true
	end
	if key=="f" and not holdingKey then
		addingFood = true
		holdingKey = true
	end
	if key=="p" then
		if currentCell ~= nil then
			if parent1 == nil then parent1 = currentCell
			elseif parent2 == nil then parent2 = currentCell
			else
				parent1 = nil
				parent2 = nil
			end
		end
	end
	if key == "b" and not holdingKey then
		if parent1 ~= nil and parent2 ~= nil then
			breedOnClick = true
			holdingKey = true
		end
	end
	if key == "k" and currentCell ~= nil then
		currentCell.markedForDeath = true
	end
	if key=="i" then
		if rendering then
			ticksPerSecond = 10000
		else
			if  paused then ticksPerSecond = 0 else ticksPerSecond = currentTickRate end
		end
		rendering = not rendering
	end
	if key=="escape" then
		love.event.quit()
	end
	if tonumber(key) ~= nil and key ~= "0" then
		local keyNum = tonumber(key)
		if savingGenome and currentCell~= nil then
			local fileName = key.."-"..currentCell.species
			local genomeTable = TSerial.pack(currentCell.genes,false)
			for i=1,table.getn(speciesFiles),1 do
				if speciesFiles[i]:sub(1,1) == key then
					love.filesystem.remove(speciesFiles[i])
				end
			end
			local success, message = love.filesystem.write(fileName,genomeTable)
			if success then
				testValue = "File Created"
			else
				testValue = 'file not created: '..message
			end
			updateSpeciesFiles()
		else
			loadingSpecies = keyNum
			holdingKey = true
		end
	end
end

function love.keyreleased(key)
	if key == 'n' then
		holdingKey = false
		addingNewCells = false
	end
	if key == 'g' then
		holdingKey = false
		savingGenome = false
	end
	if key == 'f' then
		holdingKey = false
		addingFood = false
	end
	if key == 'b' then
		holdingKey = false
		breedOnClick = false
	end
	if tonumber(key) ~= nil and key ~= "0" then
		loadingSpecies = false
		holdingKey = false
	end
end
function love.mousepressed(x, y, button, istouch)
   	if button == 1  and not holdingKey then
	   	currentCell = getClosestCell(x,y)
   	end
	if button == 2 then
	   	currentCell = nil
   	end
	if x < WIDTH then
		if addingFood then
			newFood(x,y)
		elseif addingNewCells then
			newCell(x,y,startingEnergy)
		elseif loadingSpecies ~= false then
			local speciesToLoad = nil
			for i=1,table.getn(speciesFiles),1 do
				if speciesFiles[i]:sub(1,1) == tostring(loadingSpecies) then
					speciesToLoad = i
					break
				end
			end
			if speciesToLoad ~= nil then
				local tmpFile = love.filesystem.read(speciesFiles[speciesToLoad])
				if tmpFile ~= nil then
					local genome = TSerial.unpack(tmpFile)
					newCell(x,y,startingEnergy,genome,speciesFiles[speciesToLoad]:sub(3,-1).."*")
				end
			end
		elseif breedOnClick then
			cross(parent1,parent2,x,y,startingEnergy)
		end
	end
end

function love.mousereleased(x, y, button, isTouch)
end

function love.mousemoved(x, y, dx, dy, istouch)
end

function love.wheelmoved(x, y)
end

function love.draw()
	local actualTickRate = ticksPerSecond
	if fps<ticksPerSecond then actualTickRate = round(fps) end

	--love.graphics.print("TestValue: "..tostring(testValue),20,80)
	if rendering==true then
		for i,f in pairs(foodList) do
			drawFood(f)
		end
		for i,c in pairs(cellList) do
			drawCell(c)
		end
		if parent1 ~= nil then
			love.graphics.setColor(1, 0, 0, 0.5)
			love.graphics.setLineWidth(4)
			love.graphics.circle("line", parent1.x, parent1.y, parent1.highestPeak+20, 20)
		end
		if parent2 ~= nil then
			love.graphics.setColor(0, 0, 1, 0.5)
			love.graphics.setLineWidth(4)
			love.graphics.circle("line", parent2.x, parent2.y, parent2.highestPeak+20, 20)
		end
		if currentCell ~= nil then
			love.graphics.setColor(1, 1, 1, 0.5)
			love.graphics.setLineWidth(1)
			love.graphics.circle("line", currentCell.x, currentCell.y, currentCell.highestPeak+20, 20)
		end
	end
	love.graphics.setColor(0,0,0,1)
	love.graphics.rectangle("fill", WIDTH, 0, panelWidth, HEIGHT)
	if currentCell ~= nil then
		drawCellStats(currentCell,WIDTH,0)
	else
		drawControls(WIDTH,0)
	end
	if not rendering then love.graphics.print("Incubating...",WIDTH/2,HEIGHT/2) end
	drawStats(-20, HEIGHT-190)

	love.graphics.setColor(1,1,1,1)
	love.graphics.print("FPS: "..tostring(round(fps)),20,20)
	love.graphics.print("Ticks per Second: "..tostring(actualTickRate),20,40)
	love.graphics.print("Living Pixies: "..tostring(table.getn(cellList)),20,60)
	love.graphics.setLineWidth(2)
	love.graphics.rectangle("line", WIDTH, 0, panelWidth, HEIGHT)
end

function newCell(_x,_y,energy,genome,species)
	local cell = {}
	numCells = numCells + 1
	cell.id = "cell"..tostring(cellID)
	cellID = cellID + 1

	cell.x = math.floor(_x/pixelSize)*pixelSize
	cell.y = math.floor(_y/pixelSize)*pixelSize
	cell.ix,cell.iy = cell.x,cell.y

	cell.age = round(math.random()*25)
	cell.facing = 1 -- 1:right, 2:down, 3:left 4:up
	cell.radius = baseRadius
	cell.resolution = 5000

	cell.generation = 0
	if genome == nil then
		cell.genes = {}
		for i=1,geneCount,1 do
			cell.genes[i] = {}
			for j=1,geneSize,1 do
				cell.genes[i][j] = math.random()*(bpMaxSize-1) + 1
			end
		end
	else
		cell.genes = genome
	end

	cell.r,cell.g,cell.b = setCellColor(cell)

	if species == nil then
		cell.species = "P"..tostring(speciesID)
		speciesList[cell.species] = 1
		speciesColors[cell.species] = {cell.r,cell.g,cell.b}
		speciesID = speciesID + 1
	else
		cell.species = species
		if speciesList[cell.species] == nil then
			speciesList[cell.species] = 1
			speciesColors[cell.species] = {cell.r,cell.g,cell.b}
		else
			speciesList[cell.species] = speciesList[cell.species] + 1
		end
	end

	cell.wallRadius = cellWallFunction(cell)
	cell.peaks,cell.lowestTrough,cell.highestPeak = generatePeaks(cell)
	cell.body = generateCellBody(cell)
	cell.w = table.getn(cell.body[1])
	cell.h = table.getn(cell.body)
	cell.wallRadius = nil
	cell.peaks = nil

	cell.mass = getMass(cell.body)
	cell.energy = energy
	cell.breedingEnergy = cell.mass*2+100
	cell.markedForDeath = false
	cell.damage = 0
	cell.speed = 1
	cell.moveCost =  cell.mass/700
	cell.lifespan = math.sqrt(cell.mass)*200 + collisionAge

	table.insert(cellList,cell)
	cell.gridX,cell.gridY = getGrid(cell.x,cell.y)
	setGrids(cell)

	cell.senses = {}
	for i = 1,numSenses,1 do
		table.insert(cell.senses,0)
	end

	cell.actions = {}
	for i = 1,numActions,1 do
		table.insert(cell.actions,0)
	end

	cell.intangible = collisionAge
	cell.success = 0
	cell.brainGeneStart=12
	cell.peaceful = false
	cell.openToBroadcast = false
	cell.breedTimer = 0
	cell.crossBreed = false
	cell.grab = false
	cell.stunned = 0
	cell.imageData,cell.image = createImage(cell)
	cell.shake = 0

	cell.diamond = false
	cell.isAnimated = false
	cell.skin = 0
	getShader(cell)

	for i=1,2,1 do
		local rot = math.random(-1,1)
		rotateCell(cell, rot)
	end
	cell.ir = math.pi*(cell.facing-1)/2

	return cell
end


function cross (c1,c2,_x,_y,energy)
	c1.success = c1.success+2
	if c1 ~= c2 then c2.success = c2.success+2 end
	local cell = {}
	numCells = numCells + 1
	cell.id = "cell"..tostring(cellID)
	cellID = cellID + 1


	cell.x = math.floor(_x/pixelSize)*pixelSize
	cell.y = math.floor(_y/pixelSize)*pixelSize
	cell.ix,cell.iy = cell.x,cell.y
	cell.age = 0
	cell.facing = 1 -- 1:right, 2:down, 3:left 4:up
	cell.radius = baseRadius
	cell.resolution = 5000

	cell.generation = 0

	local genes = {}
	--local mutationChance = math.ceil(cell.gene)
	for i=1,geneCount,1 do
		genes[i]={}
		if math.random() > 0.5 then
			for j=1,geneSize,1 do
				genes[i][j] = c1.genes[i][j]
				if math.random() < mutationRate and i~=4 then
					genes[i][j] = mutate(genes[i][j],2)
				end
			end
		else
			for j=1,geneSize,1 do
				genes[i][j] = c2.genes[i][j]
				if math.random() < mutationRate and i~=4 then
					genes[i][j] = mutate(genes[i][j],2)
				end
			end
		end
	end
	cell.genes = genes


	cell.r,cell.g,cell.b = setCellColor(cell)

	if c1.species ~= c2.species then
		if compareGenetics(cell,c1)>compareGenetics(cell,c2) then
			cell.species = c1.species.."x"
			cell.generation = c1.generation + 1
		else
			cell.species = c2.species.."x"
			cell.generation = c2.generation + 1
		end
		if speciesList[cell.species] == nil then
			speciesList[cell.species] = 1
			speciesColors[cell.species] = {cell.r,cell.g,cell.b}
		else
			speciesList[cell.species] = speciesList[cell.species] + 1
		end
	else
		if c1.species ~= nil then cell.species = c1.species else cell.species = c2.species end
		speciesList[cell.species] = speciesList[cell.species] + 1
		cell.generation = c1.generation + 1
	end

	cell.wallRadius = cellWallFunction(cell)
	cell.peaks,cell.lowestTrough,cell.highestPeak = generatePeaks(cell)
	cell.body = generateCellBody(cell)
	cell.w = table.getn(cell.body[1])
	cell.h = table.getn(cell.body)
	cell.wallRadius = nil
	cell.peaks = nil

	cell.mass = getMass(cell.body)
	cell.energy = energy
	cell.breedingEnergy = cell.mass*2 + 100
	cell.markedForDeath = false
	cell.damage = 0
	cell.speed = 1
	cell.moveCost = cell.mass/700
	cell.lifespan = math.sqrt(cell.mass)*200 + collisionAge

	table.insert(cellList,cell)
	cell.gridX,cell.gridY = getGrid(cell.x,cell.y)
	setGrids(cell)

	cell.senses = {}
	for i = 1,numSenses,1 do
		table.insert(cell.senses,0)
	end

	cell.actions = {}
	for i = 1,numActions,1 do
		table.insert(cell.actions,0)
	end

	cell.intangible = collisionAge
	cell.success = 0
	cell.brainGeneStart = 12
	cell.peaceful = false
	cell.openToBroadcast = false
	cell.donateEnergy=false
	cell.breedTimer = 0
	cell.crossBreed = false
	cell.grab = false
	cell.stunned = 0
	cell.imageData,cell.image = createImage(cell)
	cell.shake = 0


	cell.diamond = false
	cell.isAnimated = false
	cell.skin = 0
	cell.shaderID = getShader(cell)

	for i=1,2,1 do
		local rot = math.random(-1,1)
		rotateCell(cell, rot)
	end
	cell.ir = math.pi*(cell.facing-1)/2

	return cell
end

function cellWallFunction(cell)
	local start = 6
	local g=cell.genes
	local radii = {}
	local angleStart = math.pi*(g[5][6]-g[5][7])/bpMaxSize
	local angleRange = (g[5][1]+math.sqrt(g[5][2]))/3
	local angleIncrement = angleRange / cell.resolution
	local scale = math.sqrt(cell.radius*g[5][3]) / (2+g[5][4]/5)
	local reduceSize = false
	local largestR = 0
	for angle=angleStart,angleRange+angleStart,angleIncrement do
		local r = 0
		r = r + (0.5*math.asin(math.cos(angle*g[start][1]/g[start][2]))*g[start][3]/g[start][4])*(round(g[start][5])%3)
		r = r + (0.25*math.acos(math.sin(angle*g[start+1][1]/g[start+1][2]))*g[start+1][3]/g[start+1][4])*(round(g[start+1][5])%3)
		r = r + (math.cos(angle*(g[start+2][1]/4)/g[start+2][2])*(g[start+2][3]/g[start+2][4]))*(round(g[start+2][5])%3)
		r = r + (math.abs(math.sin(angle*g[start+3][1]/g[start+3][2])*g[start+3][3]/g[start+3][4]) - math.cos(angle*g[start+3][5]/g[start+3][6])*g[start+3][7]/g[start+3][8])*(round(g[start+3][9])%3)
		r = r + ((1-math.abs(math.cos(angle*g[start+4][1]/g[start+4][2])))*(g[start+4][3]/g[start+4][4]))*(round(g[start+4][5])%3)
		r = r + 2*(math.cos((g[start+5][1]*0.5)*angle)^(g[start+5][2]+1))*(g[start+5][3]-g[start+5][4])*(round(g[start+5][5])%3)
		r = r - (math.sin(angle*(g[start+6][1]/3)/g[start+6][2])*(g[start+6][3]/2/g[start+6][4]))*(round(g[start+6][5])%3)
		if g[5][8]%2==0 then r = r*math.abs(math.cos(angle^2))*1.5 end
		r = math.abs(r*scale) + g[5][5] + 2*pixelSize-1
		if r>maxRadius then
			reduceSize = true
			if r>largestR then largestR=r end
		end
		table.insert(radii,r)
	end
	if reduceSize == true then
		for i=1,cell.resolution,1 do
			radii[i] = radii[i]*(maxRadius/largestR)
			if radii[i] < 2*pixelSize then radii[i] = 2*pixelSize end
		end
	end
	for i=1,cell.resolution-1,1 do
		radii[i+cell.resolution] = radii[cell.resolution-i]
	end
	return radii
end

function generateCellBody(cell)
	local wr = cell.wallRadius
	local body = {}
	local xCoords = {}
	local yCoords = {}
	local step = math.pi/cell.resolution
	local highestX,lowestX,highestY,lowestY = 0,0,0,0
	local cellAngle = (cell.facing-1)*math.pi/2
	local oldx, oldy
	for i = 0,table.getn(wr)-1,1 do
		local rad = wr[i+1]
		if rad < pixelSize then rad = pixelSize end
		local x = math.floor((math.cos(i*step+cellAngle)*rad)/pixelSize)
		local y = math.floor((math.sin(i*step+cellAngle)*rad)/pixelSize)

		if x > highestX then highestX = x
		elseif x < lowestX then lowestX = x end
		if y > highestY then highestY = y
		elseif y < lowestY then lowestY = y end

		if i>0 then
			if math.abs(x-oldx)>1 or math.abs(y-oldy)>1 then
				if x-oldx>0 then local xInc = 1 else local xInc = -1 end
				if y-oldy>0 then local yInc = 1 else local yInc = -1 end
				for tmpX = oldx,x,xInc do
					for tmpY = oldy,y,yInx do
						table.insert(xCoords,tmpX)
						table.insert(yCoords,tmpY)
					end
				end
			end
		end
		table.insert(xCoords,x)
		table.insert(yCoords,y)
		oldx = x
		oldy = y
	end
	local h = (highestY-lowestY)+4
	local w = (highestX-lowestX)+4
	for i =1,h,1 do
		body[i] = {}
		for j = 1,w,1 do
			body[i][j] = 0
		end
	end
	for i=1,table.getn(xCoords),1 do
		if body[yCoords[i]-lowestY+2] ~= nil and body[yCoords[i]-lowestY+2][xCoords[i]-lowestX+2] ~= nil then
			body[yCoords[i]-lowestY+2][xCoords[i]-lowestX+2] = 1
		end
	end
	body = trimArray(body)

	local cy = math.ceil(table.getn(body)/2)
	local cx = math.ceil(table.getn(body[1])/2)
	local toCheck = {{cx,cy}}
	local maxY = table.getn(body)-1
	local maxX = table.getn(body[1])-1
	while table.getn(toCheck) > 0 do
		local x,y=toCheck[1][1],toCheck[1][2]
		if body[y]==nil or body[y][x]==nil then break end
		body[y][x]=1
		if y>=maxY or y<=1 or x>=maxX or x<=1 then goto continue end
		if body[y][x+1] == 0 then
			body[y][x+1] = 1
			table.insert(toCheck,{x+1,y})
		end
		if body[y][x-1] == 0 then
			body[y][x-1] = 1
			table.insert(toCheck,{x-1,y}) end
		if body[y+1][x] == 0 then
			body[y+1][x] = 1
			table.insert(toCheck,{x,y+1})
		end
		if body[y-1][x] == 0 then
			body[y-1][x] = 1
			table.insert(toCheck,{x,y-1})
		end
		::continue::
		table.remove(toCheck,1)
	end
	local cy = math.ceil(table.getn(body)/2)
	local cx = math.ceil(table.getn(body[1])/2)
	if cx<1 or cx==nil then cx=1 end
	if cy<1 or cy==nil then cy=1 end
	body[cy][cx]=2
	return body
end

function drawCell(cell)

	if cell.age < collisionAge then
		love.graphics.setColor(1,1,1,0.5)
		local s = pixelSize*(0.5*cell.age/collisionAge+0.5)
		love.graphics.draw(cell.image, cell.x, cell.y, math.pi*(cell.facing-1)/2, s, s, math.floor(cell.image:getWidth()/2), math.floor(cell.image:getHeight()/2))
	else

		love.graphics.setColor(1,1,1,1)
		if cell.updateImage then cell.image = love.graphics.newImage(cell.imageData) end
		local ox = 0
		local oy = 0
		if cell.shake > 0 then
			ox = (2*math.random()-1)*cell.shake
			oy =  (2*math.random()-1)*cell.shake
		end
		if cell.breedTimer < 15 and cell.breedTimer%2 == 0 then
			love.graphics.setShader(flashShader)
		else
			love.graphics.setShader(cell.shader)
		end
		local tween = 0.05
		cell.ix = cell.ix+tween*(cell.x-cell.ix)
		cell.iy = cell.iy+tween*(cell.y-cell.iy)

		cell.ir = cell.ir+tween*angleDifference(cell.ir,math.pi*(cell.facing-1)/2)

		love.graphics.draw(cell.image, cell.ix+ox, cell.iy+oy, cell.ir, pixelSize, pixelSize, math.floor(cell.image:getWidth()/2), math.floor(cell.image:getHeight()/2))
		love.graphics.setShader()
		--love.graphics.points(cell.x, cell.y)
		cell.updateImage = false
	end

end

function angleDifference(a1,a2)
	local diff = (a2-a1+math.pi)%(2*math.pi) - math.pi
	if diff < -math.pi then return diff+2*math.pi else return diff end
end

function generatePeaks(cell)
	local peaks = {}
	local highestPeak = 0
	local lowestTrough = cell.radius*0.75
	peaks[1]=1
	for i=2,table.getn(cell.wallRadius)-1,1 do
		peaks[i] = 0
		if cell.wallRadius[i-1] < cell.wallRadius[i] and cell.wallRadius[i+1] < cell.wallRadius[i] then
			peaks[i] = 1
			if cell.wallRadius[i] > highestPeak then
				highestPeak = cell.wallRadius[i]
			end
		elseif cell.wallRadius[i-1] > cell.wallRadius[i] and cell.wallRadius[i+1] > cell.wallRadius[i] then
			peaks[i] = -1
			if cell.wallRadius[i] < lowestTrough then
				lowestTrough = cell.wallRadius[i]
			end
		end
	end
	peaks[table.getn(cell.wallRadius)] = 1
	peaks[math.floor(table.getn(cell.wallRadius)/2)] = 1
	return peaks,lowestTrough,highestPeak
end

function setCellColor(cell)
	local r = 0.7*(cell.genes[1][1]-1)/(bpMaxSize-1) + 0.1
	local g = 0.7*(cell.genes[1][2]-1)/(bpMaxSize-1) + 0.1
	local b = 0.7*(cell.genes[1][3]-1)/(bpMaxSize-1) + 0.1
	return r,g,b
end

function getClosestCell(x,y,exclusion)
	local cell = nil
	local closestDistance = 10000000
	for i,c in pairs(cellList) do
		local d = (c.x-x)^2 + (c.y-y)^2
		if d<closestDistance and c~=exclusion then
			closestDistance = d
			cell = c
		end
	end
	return cell
end

function sum(t)
    local sum = 0
    for k,v in pairs(t) do
        sum = sum + v
    end
    return sum
end

function trimEmptyRows(array)
	for i = table.getn(array),1,-1 do
		if sum(array[i]) == 0 then
			table.remove(array,i)
		end
	end
	return array
end

function trimArray(array)
	array = trimEmptyRows(array)
	array = rotateLeft(array)
	array = trimEmptyRows(array)
	array = rotateRight(array)
	return array
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function rotateRight(oldArray)
	local w = table.getn(oldArray[1])
	local h = table.getn(oldArray)
	local newArray = {}
	for i = 1,w,1 do
		newArray[i] = {}
		for j=1,h,1 do
			newArray[i][j] = oldArray[h-(j-1)][i]
		end
	end
	return newArray
end

function rotateLeft(oldArray)
	if oldArray == nil then oldArray = {{1,1},{1,1}} end
	if oldArray[1] == nil then oldArray[1] = {1,1} end
	local w = table.getn(oldArray[1])
	local h = table.getn(oldArray)
	local newArray = {}
	for i = 1,w,1 do
		newArray[i] = {}
		for j=1,h,1 do
			newArray[i][j] = oldArray[j][w-(i-1)]
		end
	end
	return newArray
end

function rotateCell(cell,direction)
	if direction == 1 then
		cell.body=rotateRight(cell.body)
	elseif direction == -1 then
		cell.body=rotateLeft(cell.body)
	end
	cell.w = table.getn(cell.body[1])
	cell.h = table.getn(cell.body)
	cell.x = math.floor(cell.x/pixelSize)*pixelSize
	cell.y = math.floor(cell.y/pixelSize)*pixelSize
	cell.facing = cell.facing+direction
	if cell.facing < 1 then cell.facing=4 end
	if cell.facing > 4 then cell.facing=1 end
	if cell.diamond then cell.shader:send("rot",cell.facing) end
	cell.energy = cell.energy - cell.moveCost*3
end

function moveCell(cell,v)
	local moveTable = {{1,0},{0,1},{-1,0},{0,-1}}
	local vx,vy = moveTable[cell.facing][1]*v,moveTable[cell.facing][2]*v
	cell.x = math.floor(cell.x+vx*pixelSize)
	cell.y = math.floor(cell.y+vy*pixelSize)
	cell.x = math.floor(cell.x/pixelSize)*pixelSize
	cell.y = math.floor(cell.y/pixelSize)*pixelSize
	local intangTime = 5
	if cell.x>WIDTH-pixelSize then
		cell.x=pixelSize
		cell.intangible = intangTime
		cell.ix = cell.x
	end
	if cell.x<pixelSize then
		cell.x=WIDTH-pixelSize
		cell.intangible = intangTime
		cell.ix = cell.x
	end
	if cell.y>HEIGHT-pixelSize then
		cell.y=pixelSize
		cell.intangible = intangTime
		cell.iy = cell.y
	end
	if cell.y<pixelSize then
		cell.y=HEIGHT-pixelSize
		cell.intangible = intangTime
		cell.iy = cell.y
	end
	local oldGX,oldGY = cell.gridX,cell.gridY
	local newGX,newGY = getGrid(cell.x,cell.y)
	if oldGX ~= newGX or oldGY ~= newGY then
		cell.gridX,cell.gridY = newGX,newGY
		setGrids(cell)
	end
	if v~=0 then
		cell.energy = cell.energy-(v*v*cell.moveCost)
		cell.age = cell.age-0.5
	else
		cell.energy = cell.energy-cell.moveCost*0.5
		cell.age = cell.age + 5
	end
end

function getMass(body)
	local mass = 0
	for i=1,table.getn(body),1 do
		for j=1,table.getn(body[i]),1 do
			mass = mass + body[i][j]
		end
	end
	return mass*pixelSize
end

function killCell(cell)
	if cell ~= nil then
		if cell == currentCell then currentCell = nil end
		if cell == parent1 then parent1 = nil end
		if cell == parent2 then parent2 = nil end
		if cell.species ~= nil then speciesList[cell.species] = speciesList[cell.species] - 1 end
		if speciesList[cell.species] == 0 then
			table.removekey(speciesList,cell.species)
			table.removekey(speciesColors,cell.species)
		end
		for i=1,gridSize,1 do
			for j=1,gridSize,1 do
				if cellGrids[i][j][cell.id] ~= nil then
					table.removekey(cellGrids[i][j],cell.id)
				end
			end
		end
		for i=1,table.getn(cellList),1 do
			if cellList[i] == cell then table.remove(cellList,i) end
		end
		cell.id = nil
		cell = nil
		numCells = numCells - 1
	end
end

function table.removekey(table, key)
    local element = table[key]
    table[key] = nil
    return element
end

function getGrid(x,y)
	local gridWidth = WIDTH/gridSize
	local gridHeight = HEIGHT/gridSize
	local gridX = math.ceil(x/gridWidth)
	local gridY = math.ceil(y/gridHeight)
	if gridX < 1 then gridX=1 end
	if gridX > gridSize then gridX = gridSize end
	if gridY < 1 then gridY=1 end
	if gridY > gridSize then gridY = gridSize end
	return gridX,gridY
end

function setGrids(cell)
	--Clear old grids
	for i=1,gridSize,1 do
		for j=1,gridSize,1 do
			if cellGrids[i][j][cell.id] ~= nil then
				table.removekey(cellGrids[i][j],cell.id)
			end
		end
	end
	--Add to new grids
	local gridX,gridY = cell.gridX,cell.gridY
	local minY,maxY,minX,maxX = gridY,gridY,gridX,gridX
	if gridY>1 then minY = gridY-1 end
	if gridY<gridSize then maxY = gridY+1 end
	if gridX>1 then minX = gridX-1 end
	if gridX<gridSize then maxX = gridX+1 end
	for Y = minY,maxY,1 do
		for X = minX,maxX,1 do
			if cellGrids[Y] ~= nil and cellGrids[Y][X] ~= nil and cell.id ~= nill then
				cellGrids[Y][X][cell.id] = cell
			end
		end
	end
end

function checkCollisions()
	for i=1,table.getn(cellList)-2,1 do
		local c1 = cellList[i]
		for j = i+1,table.getn(cellList),1 do
			local c2 = cellList[j]
			if c2.id ~= c1.id and c1.intangible == 0 and c2.intangible == 0 then
				local dx = (c2.x - c1.x)/pixelSize
				local dy = (c2.y - c1.y)/pixelSize
				local collisionWidth = math.ceil((c1.w + c2.w)/2)
				local collisionHeight = math.ceil((c1.h + c2.h)/2)
				if math.abs(dx) < collisionWidth and math.abs(dy) < collisionHeight then
					local overlapX = math.abs(collisionWidth-dx)
					local overlapY = math.abs(collisionHeight-dy)
					if c1.crossBreed==true and c2.crossBreed==true then
						if c1.breedTimer>200 and c2.breedTimer>200 then
							if c1.species == c2.species then
								local crossEnergy = 1.9*(c1.energy+c2.energy)/3
								c1.energy = c1.energy*0.6
								c2.energy = c2.energy*0.6
								c1.breedTimer = 0
								c2.breedTimer = 0
								cross(c1,c2,(c1.x+c2.x)/2,(c1.y+c2.y)/2,math.random(1,4),crossEnergy)
							end
						end
					end
					if overlapX>1 or overlapY>1 then
						if c1.mass>c2.mass and c1.grab then
							c2.stunned = 1
							c2.energy = c2.energy - c2.moveCost
						elseif c2.mass>c1.mass and c2.grab then
							c1.stunned = 1
							c1.energy = c1.energy - c1.moveCost
						end
					end
					if c1.peaceful ~= true or c2.peaceful ~= true then
						if c1.stunned==0 or c2.stunned==0 then
							collide(c1,c2,overlapX,overlapY)
						end
					end
				end
			end
		end
	end
end

function collide(c1,c2,dx,dy)
	local c
	local other
	if c1.w * c1.h > c2.w * c2.h then
		c = c2
		co = c1
	else
		c = c1
		co = c2
	end
	local minX = 1
	local maxX = c.w
	local minY = 1
	local maxY = c.h

	if co.x>c.x then
		minX = c.w-dx
	else
		maxX = dx
	end

	if co.y>c.y then
		minY = c.h-dy
	else
		maxY = dy
	end

	if minX<1 then minX = 1 end
	if minY<1 then minY = 1 end
	if maxX > c.w then maxX = c.w end
	if maxY > c.h then maxY = c.h end

	local cx = math.floor(c.x/pixelSize)
	local cy = math.floor(c.y/pixelSize)
	local crx = math.floor(c.w/2)
	local cry = math.floor(c.h/2)

	local ocx = math.floor(co.x/pixelSize)
	local ocy = math.floor(co.y/pixelSize)
	local ocrx = math.floor(co.w/2)
	local ocry = math.floor(co.h/2)

	for y=minY,maxY,1 do
		for x=minX,maxX,1 do
			if c.body[y] ~= nil and c.body[y][x] ~= nil and c.body[y][x] > 0 then
				local _x = cx+(x-crx)
				local _y = cy+(y-cry)
				local ox = _x-ocx+ocrx
				local oy = _y-ocy+ocry
				if co.body[oy] ~= nil and co.body[oy][ox] ~= nil and co.body[oy][ox] > 0 then
					c1.updateImage = true
					c2.updateImage = true
					local px,py = bodyToPixel(x, y, c.w, c.h, c.facing)
					local opx,opy = bodyToPixel(ox, oy, co.w, co.h, co.facing)
					if c.body[y][x] == 2 then
						if co.age > collisionAge+2 then
							if c.species == co.species then
								co.energy = co.energy+c.energy
							else
								local energyScale = 1
								if c.age<collisionAge+2 then energyScale = 0.5 end
								co.energy = co.energy+c.energy*1.5*energyScale

							end
							c.energy = 0
							c.markedForDeath = true
							co.success = co.success+3
						end
					end
					if co.body[oy][ox] == 2 then
						if c.age > collisionAge+2 then
							if c.species == co.species then
								c.energy = c.energy+co.energy
							else
								local energyScale = 1
								if co.age<collisionAge+2 then energyScale = 0.5 end
								c.energy = c.energy+co.energy*1.5*energyScale
							end
							co.energy = 0
							co.markedForDeath = true
							c.success = c.success+3
						end
					end
					if c.body[y][x] == 1 and co.body[oy][ox] == 1 then
						local r,g,b,a = c.imageData:getPixel(px,py)
						c.body[y][x] = -1
						c.imageData:setPixel(px,py,r,g,b,0.2)
						c.damage = c.damage + 1
						co.body[oy][ox] = -1
						r,g,b,a = co.imageData:getPixel(opx,opy)
						co.imageData:setPixel(opx,opy,r,g,b,0.2)
						co.damage = co.damage + 1
						c.stunned = 5
						c.shake = 3
						co.stunned = 5
						co.shake = 3
					end
					if c.mass>co.mass then
						c.energy = c.energy + pixelSize*(c.mass/(c.mass+co.mass))
						--co.energy = co.energy - pixelSize*(c.mass/(c.mass+co.mass))
					elseif co.mass > c.mass then
						co.energy = co.energy + pixelSize*(co.mass/(c.mass+co.mass))
						--c.energy = c.energy - pixelSize*(co.mass/(c.mass+co.mass))
					end
				end
			end
		end
	end
end

function bodyToPixel(x,y,w,h,dir)
	local rot = {{x-1,y-1},{y-1,w-x},{w-x,h-y},{h-y,x-1}}
	return rot[dir][1],rot[dir][2]
end
function checkHeartDamage(cell)
	local x = math.ceil(cell.w/2)
	local y = math.ceil(cell.h/2)
	if cell.body[y][x] == 0 then
		killCell(cell)
		return
	end
	if cell.markedForDeath==true then
		killCell(cell)
		return
	end
	if cell.energy < 0 then
		killCell(cell)
		return
	end
	if cell.age > cell.lifespan then killCell(cell) end

end

function newFood(x,y)
	local food = {}

	if x==nil then food.x = math.floor(math.random(20,WIDTH-20)/pixelSize)*pixelSize else food.x = round(x/pixelSize)*pixelSize end
	if y==nil then food.y = math.floor(math.random(20,HEIGHT-20)/pixelSize)*pixelSize else food.y = round(y/pixelSize)*pixelSize end
	food.gridX,food.gridY = getGrid(food.x,food.y)
	numFood = numFood + 1
	foodID = foodID+1
	food.id = "food"..tostring(foodID)
	setFoodGrids(food)
	table.insert(foodList,food)
end

function drawFood(f)
	love.graphics.setColor(0.5, 0.5, 0.5, 1)
	love.graphics.setPointSize(foodSize)
	love.graphics.points(f.x,f.y)
end

function checkFoodCollisions()
	for i=table.getn(foodList),1,-1 do
		local f = foodList[i]
		for k,c in pairs(cellGrids[f.gridY][f.gridX]) do
			local minX = (c.w*pixelSize)/3
			local minY = (c.h*pixelSize)/3
			local dx = math.abs(c.x-f.x)
			local dy = math.abs(c.y-f.y)
			local closestPossible = c.w*pixelSize/3
			if c.h < c.w then closestPossible = c.h*pixelSize/3 end
			--local dx = 18
			--local dy = dx
			if dx < minX and dy < minY then
				local d = math.sqrt(dx*dx + dy*dy)
				local energyScaler = 2*closestPossible/(closestPossible+d)
				c.energy = c.energy+foodEnergy*energyScaler
				c.success = c.success + 1
				table.remove(foodList,i)
				numFood = numFood-1
				for i=1,gridSize,1 do
					for j=1,gridSize,1 do
						if foodGrids[i][j][f.id] ~= nil then
							table.removekey(foodGrids[i][j],f.id)
						end
					end
				end
				break
			end
		end
	end
end

function setFoodGrids(f)
	--Add to new grids
	local gridX,gridY = f.gridX,f.gridY
	local minY,maxY,minX,maxX = gridY,gridY,gridX,gridX
	if gridY>1 then minY = gridY-1 end
	if gridY<gridSize then maxY = gridY+1 end
	if gridX>1 then minX = gridX-1 end
	if gridX<gridSize then maxX = gridX+1 end
	for Y = minY,maxY,1 do
		for X = minX,maxX,1 do
			if foodGrids[Y] ~= nil and foodGrids[Y][X] ~= nil and f.id ~= nill then
				foodGrids[Y][X][f.id] = f
			end
		end
	end
end

function compareGenetics(c1,c2)
	local diff = 0
	local maxDiff = geneCount*5
	for i=1,geneCount,1 do
		for j=1,5,1 do
			if c1.genes[i][j] ~= c2.genes[i][j] then diff = diff+1 end
		end
	end
	return (maxDiff-diff)/maxDiff
end

function drawStats(x,y)
	local tmpList = {}
	local barMaxHeight = 150
	local barWidth = 20
	for s,n in pairs(speciesList) do
		table.insert(tmpList,{n,s})
	end
	numSpecies = table.getn(tmpList)
	table.sort(tmpList, compare)

	for i=1,table.getn(tmpList),1 do
		if tmpList[i][1] > 0 then
			local _x = x + i*barWidth*2
			local h = (tmpList[i][1]/numCells)*barMaxHeight
			local color=speciesColors[tmpList[i][2]]
			if _x < WIDTH - barWidth then
				love.graphics.setColor(color[1], color[2], color[3], 0.5)
				love.graphics.rectangle("fill", _x, y+barMaxHeight, barWidth, h*-1)
				--love.graphics.setColor(1, 1, 1, 0.5)
				love.graphics.print(tmpList[i][1],_x,y+barMaxHeight-h-15)
				love.graphics.setColor(1, 1, 1, 1)
				local textScale = 4/string.len(tmpList[i][2])
				if textScale > 1 then textScale = 1 end
				love.graphics.print(tmpList[i][2],_x,y+barMaxHeight+10,0,textScale,textScale)
			end
		end
	end
end

function compare(a,b)
  return a[1] > b[1]
end

function drawCellStats(c,x,y)
	love.graphics.setColor(1,1,1,1)
	love.graphics.setLineWidth(1)
	local vs = 20
	local _x = x + 20
	local _y = y + 20

	love.graphics.print("Species: "..c.species,_x,_y)
	love.graphics.print("Generation: "..tostring(c.generation),_x,_y+vs*1)
	love.graphics.print("Energy: "..tostring(math.floor(c.energy)),_x,_y+vs*2)
	love.graphics.print("Mass: "..tostring(c.mass),_x,_y+vs*3)
	love.graphics.print("Breeding Energy: "..tostring(c.breedingEnergy),_x,_y+vs*4)
	love.graphics.print("Damage: "..tostring(c.damage),_x,_y+vs*5)
	love.graphics.print("Age: "..tostring(c.age),_x,_y+vs*6)
	love.graphics.print("Success: "..tostring(c.success),_x,_y+vs*7)
	love.graphics.print("Peaceful: "..tostring(c.peaceful),_x,_y+vs*8)
	love.graphics.print("Stun: "..tostring(c.stunned),_x,_y+vs*9)
	love.graphics.print("Grabbing: "..tostring(c.grab),_x,_y+vs*10)
	love.graphics.print("Brain Mode: "..tostring(c.brainGeneStart+1),_x,_y+vs*11)
	love.graphics.print("[-SENSES-]",_x,_y+vs*13)
	love.graphics.print("[-ACTIONS-]",_x+175,_y+vs*13)

	local senseNames = {"Energy","Damage","Pixi F","Pixi R","Pixi B","Pixi L","Family F","Family R","Family B","Family L","Food F","Food R","Food B","Food L","Near Mass","Near Genes","Near Age","Told|Energy","Told|Pixi","Told|Peace","Told|Turn R","Told|Turn L","Told|Switch","Told|Cross","[Always On]"}
	local actionNames = {"Stop","Peace","Boost","Turn Right","Turn Left","Repair","Divide","Switch","[Empty]","Grab","Cross Breed"}

	for i=1,numSenses,1 do
		love.graphics.print(senseNames[i]..": "..tostring(math.floor(c.senses[i]*10)/10),_x,_y+vs*(14+i))
	end
	for i=1,numActions,1 do
		love.graphics.print(actionNames[i]..": "..tostring(math.floor(c.actions[i])),_x+175,_y+vs*(14+i))
	end

	if love.mouse.getY() > _y+vs*15 and love.mouse.getY() < _y+vs*(15+numSenses) and love.mouse.getX() > WIDTH then
		local selection = math.ceil((love.mouse.getY()-(_y+vs*15))/vs)
		local tmpGene = nil
		if c.brainGeneStart+selection > table.getn(c.genes) then
			tmpGene = c.genes[table.getn(c.genes)]
		elseif c.brainGeneStart+selection < 1 then
			tmpGene = c.genes[1]
		else
			tmpGene = c.genes[c.brainGeneStart+selection]
		end
		love.graphics.print("Gene: "..tostring(c.brainGeneStart+selection),_x+100,_y+vs*13)
		for i=1,numActions,1 do
			local nuc = round(tmpGene[i]*10)/10 - 5.5
			love.graphics.print(nuc,_x+100,_y+vs*(14+i))
		end
	end

end

function mutate(value,n)
	local drift = (math.random()-math.random())*n
	if value == 10 then drift = math.abs(drift)*-1 end
	if value == 1 then drift = math.abs(drift) end
	if value+drift > bpMaxSize then return bpMaxSize end
	if value+drift < 1 then return 1 end
	return value+drift
end

function repairSelf(cell)
	for y=1,table.getn(cell.body),1 do
		for x=1,table.getn(cell.body[1]),1 do
			if cell.body[y][x] == -1 then
				cell.body[y][x] = 1
				local px,py = bodyToPixel(x,y,cell.w,cell.h,cell.facing)
				local r,g,b,a = cell.imageData:getPixel(px,py)
				cell.imageData:setPixel(px,py,r,g,b,1)
				cell.updateImage = true
			end
		end
	end
	cell.energy = cell.energy - cell.damage*pixelSize - 10
	cell.damage = 0
end

function getSenses(c)
	for i = 1,numSenses,1 do c.senses[i] = 0 end
	local rotationTable = {{1,2,3,4},{4,1,2,3},{3,4,1,2},{2,3,4,1}}
	local sd = c.highestPeak
	c.senses[1] = (c.energy/c.breedingEnergy)
	c.senses[2] = (c.damage/(c.mass/pixelSize))*3
	for k,c2 in pairs(cellGrids[c.gridY][c.gridX]) do
		if c.id ~= c2.id then
			local dx = c2.x-c.x
			local dy = c2.y-c.y
			local d = math.sqrt(dx*dx+dy*dy)
			local signal = 4*sd/(d+sd)
			local angle = math.atan2(dy,dx)
			local ySignal = signal*math.sin(angle)
			local xSignal = signal*math.cos(angle)
			local a = nil
			local b = nil
			if xSignal >= 0 then a = rotationTable[c.facing][1] else a = rotationTable[c.facing][3] end
			if ySignal >= 0 then b = rotationTable[c.facing][2] else b = rotationTable[c.facing][4] end
			if c.species ~= c2.species then
				c.senses[a+2]=c.senses[a+2]+math.abs(xSignal)
				c.senses[b+2]=c.senses[b+2]+math.abs(ySignal)
			else
				c.senses[a+6]=c.senses[a+6]+math.abs(xSignal)
				c.senses[b+6]=c.senses[b+6]+math.abs(ySignal)
			end
		end
	end
	for k,f in pairs(foodGrids[c.gridY][c.gridX]) do
		local dx = f.x-c.x
		local dy = f.y-c.y
		local d = math.sqrt(dx*dx+dy*dy)
		local signal = sd/(d+sd)
		local angle = math.atan2(dy,dx)
		local ySignal = (3/foodDensity)*signal*math.sin(angle)
		local xSignal = (3/foodDensity)*signal*math.cos(angle)
		local a = nil
		local b = nil
		if xSignal >= 0 then a = rotationTable[c.facing][1] else a = rotationTable[c.facing][3] end
		if ySignal >= 0 then b = rotationTable[c.facing][2] else b = rotationTable[c.facing][4] end
		c.senses[a+10]=c.senses[a+10]+math.abs(xSignal)
		c.senses[b+10]=c.senses[b+10]+math.abs(ySignal)
	end
	local nearestCell = getClosestCell(c.x,c.y,c)
	c.senses[15] = nearestCell.mass/c.mass
	if c.senses[15]>3 then c.senses[15] = 3 end
	c.senses[16] = 2*compareGenetics(c,nearestCell)
	c.senses[17] = 3 - 3*(nearestCell.age/collisionAge)
	if c.senses[17] < 0 then c.senses[17] = 0 end
	for i=1,table.getn(broadcasts),1 do
		if broadcasts[i][1] ~= c.id and broadcasts[i][5] == c.species then
			local bc = broadcasts[i]
			local xd = math.abs(bc[2]-c.x)
			local yd = math.abs(bc[3]-c.y)
			if xd<200 and yd<200 then
				local dist = math.sqrt(xd^2+yd^2)
				local factor = 0.005*(282-dist)
				for j=1,7,1 do
					c.senses[j+16] = c.senses[j+17]+bc[4][j]*factor
				end
			end
		end
	end
	c.senses[numSenses] = 2
end

function getActions(c)
	c.speed = 1
	c.brainGeneStart = 12
	c.peaceful = false
	c.crossBreed = false
	c.grab = false
	for i=1,numActions,1 do
		c.actions[i] = 0
	end
	local rotate = 0

	for i=1,numSenses,1 do
		local impulse = 0
		local sense = c.senses[i]
		local gene = c.genes[c.brainGeneStart+i]
		for j = 1,numActions,1 do
			impulse = impulse + sense*gene[j]
			c.actions[j] = c.actions[j] + sense*(gene[j]-bpMaxSize/2-0.5)
		end
	end
	local actionTotal = 0
	for i=1,numActions,1 do
		actionTotal = actionTotal + c.actions[i]
	end
	local actionAverage = actionTotal/numActions
	local triggerThreshold = 15
	if c.actions[1]>triggerThreshold and c.actions[1] > actionAverage then
		c.speed = 0
	end
	if c.actions[2]>triggerThreshold and c.actions[2] > actionAverage then
		c.peaceful = true
	end
	if c.actions[3]>triggerThreshold and c.actions[3] > actionAverage then
		c.speed = 2
	end
	if c.actions[4]>triggerThreshold and c.actions[4] > actionAverage then
		rotate = rotate+1
	end
	if c.actions[5]>triggerThreshold and c.actions[5] > actionAverage then
		rotate = rotate-1
	end
	if c.actions[6]>triggerThreshold and c.actions[6] > actionAverage then
		repairSelf(c)
	end
	if c.actions[7]>triggerThreshold and c.energy > c.breedingEnergy and c.breedTimer > 200 then
		cross(c,c,c.x,c.y,c.energy/2.2)
		c.energy = c.energy/2.2
		c.shake = 10
		c.stunned = 25
		c.breedTimer = 0
	end
	if c.actions[8]>triggerThreshold*1.2 and c.actions[8] > actionAverage then
		c.brainGeneStart = 35
	end
	if c.actions[9]>triggerThreshold and c.actions[9] > actionAverage then
		--c.speed = -1
	end
	if c.actions[10]>triggerThreshold and c.actions[10] > actionAverage then
		c.grab = true
	end
	if c.actions[11]>triggerThreshold and c.actions[11] > actionAverage then
		c.crossBreed = true
	end

	if c.age>collisionAge then
		if rotate ~= 0 then
			rotateCell(c,rotate)
		end
		moveCell(c,c.speed)
		broadcast(c)
	end
end

function broadcast(c)
	local scaler = 10
	local bcSenses = {c.senses[1], (c.senses[3]+c.senses[5])/2, c.actions[2]/scaler, c.actions[4]/scaler, c.actions[5]/scaler, c.actions[8]/scaler, c.actions[11]/scaler}
	local tmpTable = {c.id,c.x,c.y,c.senses,c.species}
	table.insert(broadcasts,tmpTable)
end

function updateSpeciesFiles()
	speciesFiles = {}
	local files = love.filesystem.getDirectoryItems("")
	for k, file in ipairs(files) do
		if file:sub(3,3)=="P" then
			table.insert(speciesFiles,file)
		end
	end
	table.sort(speciesFiles)
end

function round(n)
	return math.floor(n+0.5)
end

function drawControls(x,y)
	love.graphics.setColor(1,1,1,1)
	local vs = 20
	local _x = x + 20
	local _y = y + 20
	love.graphics.print("CONTROLS:",_x-5,_y-5)
	love.graphics.print("Pause:  Spacebar",_x,_y+vs*1)
	love.graphics.print("Speed Up:  Up Arrow",_x,_y+vs*2)
	love.graphics.print("Slow Down:  Down Arrow",_x,_y+vs*3)
	love.graphics.print("Incubate (max speed):  i",_x,_y+vs*4)

	love.graphics.print("Select Pixi:  Left Click",_x,_y+vs*6)
	love.graphics.print("Deselect Pixi:  Right Click",_x,_y+vs*7)
	love.graphics.print("Kill Pixi:  K",_x,_y+vs*8)

	love.graphics.print("Create Random Pixi:  N + Click",_x,_y+vs*10)
	love.graphics.print("Add Food:  F + Click",_x,_y+vs*11)

	love.graphics.print("Select / Deselect Parents:  P",_x,_y+vs*13)
	love.graphics.print("Breed Parents:  B",_x,_y+vs*14)

	love.graphics.print("Save Cell Genome to Slot:  G + Slot Number (1-9)",_x,_y+vs*16)
	love.graphics.print("Load Saved Cell:  Slot Number (1-9) + Click",_x,_y+vs*17)

	love.graphics.print("SAVED SPECIES:",_x,_y+vs*19.5)
	for i = 1,9,1 do
		love.graphics.print("Slot "..tostring(i)..":",_x+20,_y+vs*(20+i))
		for j=1,table.getn(speciesFiles),1 do
			if speciesFiles[j]:sub(1,1) == tostring(i) then
				love.graphics.print("Slot "..tostring(i)..": "..speciesFiles[j]:sub(3,-1),_x+20,_y+vs*(20+i))
			end
		end
	end
end

function createImage(c)
	local imageData = love.image.newImageData(c.w, c.h)
	for y=0,c.h-1,1 do
		for x=0,c.w-1,1 do
			local bodyPixel = c.body[y+1][x+1]
			if bodyPixel == 1 then imageData:setPixel(x, y, c.r, c.g, c.b, 1)
			elseif bodyPixel == 2 then imageData:setPixel(x, y, c.r*2, c.g*2, c.b*2, 1)
			elseif bodyPixel == -1 then imageData:setPixel(x, y, c.r, c.g, c.b, 0.2) end
		end
	end
	local image = love.graphics.newImage(imageData)
	return imageData,image
end
